// Decompiled by Jad v1.5.5.3. Copyright 1997-98 Pavel Kouznetsov.
// Jad home page:      http://web.unicom.com.cy/~kpd/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   Complex.java

package VisualNumerics.math;


// Referenced classes of package VisualNumerics.math:
//            Sfun

public class Complex
{

    public Complex()
    {
        re = 0.0D;
        im = 0.0D;
    }

    public Complex(double d)
    {
        re = d;
        im = 0.0D;
    }

    public Complex(double d, double d1)
    {
        re = d;
        im = d1;
    }

    public Complex(Complex complex)
    {
        re = complex.re;
        im = complex.im;
    }

    public static double abs(Complex complex)
    {
        double d = Math.abs(complex.re);
        double d1 = Math.abs(complex.im);
        if(d + d1 == 0.0D)
            return 0.0D;
        if(d > d1)
        {
            d1 /= d;
            return d * Math.sqrt(1.0D + d1 * d1);
        }
        else
        {
            d /= d1;
            return d1 * Math.sqrt(d * d + 1.0D);
        }
    }

    public static Complex acos(Complex complex)
    {
        return subtract(1.5707963267948966D, asin(complex));
    }

    public Complex add(double d)
    {
        re += d;
        return this;
    }

    public static Complex add(double d, Complex complex)
    {
        return new Complex(d + complex.re, complex.im);
    }

    public Complex add(Complex complex)
    {
        re += complex.re;
        im += complex.im;
        return this;
    }

    public static Complex add(Complex complex, double d)
    {
        return new Complex(complex.re + d, complex.im);
    }

    public static Complex add(Complex complex, Complex complex1)
    {
        return new Complex(complex.re + complex1.re, complex.im + complex1.im);
    }

    public static double argument(Complex complex)
    {
        return Math.atan2(complex.im, complex.re);
    }

    public static Complex asin(Complex complex)
    {
        Complex complex4 = new Complex();
        Complex complex1 = complex;
        double d = abs(complex1);
        if(d <= 0.10000000000000001D)
        {
            if(d < 2.58095E-008D)
                return complex1;
            Complex complex2 = multiply(complex1, complex1);
            for(int i = 1; i <= 8; i++)
            {
                double d1 = 2 * (8 - i) + 1;
                complex4 = multiply(multiply(complex4, complex2), d1 / (d1 + 1.0D));
                complex4.re += 1.0D / d1;
            }

            complex4.multiply(complex1);
        }
        else
        {
            if(complex1.re < 0.0D)
                complex1 = negate(complex);
            Complex complex5 = new Complex(0.0D, 1.0D);
            Complex complex3 = sqrt(add(complex1, 1.0D));
            if(complex3.im < 0.0D)
                complex3 = negate(complex3);
            Complex complex6 = sqrt(subtract(complex1, 1.0D));
            Complex complex7 = log(add(complex1, multiply(complex3, complex6)));
            complex7.multiply(complex5);
            complex4 = subtract(1.5707963267948966D, complex7);
            if(complex4.re > 1.5707963267948966D)
                complex4 = subtract(3.1415926535897931D, complex4);
            else
            if(complex4.re <= -1.5707963267948966D)
                complex4 = subtract(-3.1415926535897931D, complex4);
            if(complex.re < 0.0D)
                complex4 = negate(complex4);
        }
        return complex4;
    }

    public static Complex conjugate(Complex complex)
    {
        return new Complex(complex.re, -complex.im);
    }

    public static Complex cos(Complex complex)
    {
        return new Complex(Math.cos(complex.re) * Sfun.cosh(complex.im), -Math.sin(complex.re) * Sfun.sinh(complex.im));
    }

    public Complex divide(double d)
    {
        re /= d;
        im /= d;
        return this;
    }

    public Complex divide(Complex complex)
    {
        Complex complex1 = divide(this, complex);
        re = complex1.re;
        im = complex1.im;
        return this;
    }

    public static Complex divide(Complex complex, double d)
    {
        return new Complex(complex.re / d, complex.im / d);
    }

    public static Complex divide(Complex complex, Complex complex1)
    {
        Complex complex2;
        if(Math.abs(complex1.re) > Math.abs(complex1.im))
        {
            double d2 = complex1.im / complex1.re;
            double d = complex1.re + complex1.im * d2;
            complex2 = new Complex((complex.re + complex.im * d2) / d, (complex.im - complex.re * d2) / d);
        }
        else
        {
            double d3 = complex1.re / complex1.im;
            double d1 = complex1.im + complex1.re * d3;
            complex2 = new Complex((complex.im + complex.re * d3) / d1, (complex.im * d3 - complex.re) / d1);
        }
        return complex2;
    }

    public boolean equals(Complex complex)
    {
        return re == complex.re && im == complex.im;
    }

    public boolean equals(Object obj)
    {
        Double double1 = new Double(re);
        Double double2 = new Double(im);
        if(obj == null || !(obj instanceof Number))
        {
            return false;
        }
        else
        {
            Double double3 = new Double(((Number)obj).doubleValue());
            Double double4 = new Double(0.0D);
            return double1.equals(double3) && double2.equals(double4);
        }
    }

    public static Complex exp(Complex complex)
    {
        double d = complex.re != 0.0D ? Math.exp(complex.re) : 1.0D;
        if(Double.isInfinite(d))
            return INFINITY;
        if(complex.im == 0.0D)
            return new Complex(d, complex.im);
        else
            return new Complex(d * Math.cos(complex.im), d * Math.sin(complex.im));
    }

    public static boolean isInfinite(Complex complex)
    {
        return Double.isInfinite(complex.re) || Double.isInfinite(complex.im);
    }

    public static boolean isNaN(Complex complex)
    {
        return Double.isNaN(complex.re) || Double.isNaN(complex.im);
    }

    private static Complex l_c_proc_cs(Complex complex)
    {
        double d = 2D;
        double d1 = 7.4505800000000001E-009D;
        double d2 = complex.im / complex.re;
        if(Math.abs(d2) <= d1)
        {
            return new Complex(1.0D, 0.5D * d2);
        }
        else
        {
            double d3 = 1.0D / d2;
            double d6 = d3 < 0.0D ? -Math.sqrt(1.0D + d3 * d3) : Math.sqrt(1.0D + d3 * d3);
            double d4 = 1.0D / (d3 + d6);
            double d5 = 1.0D / Math.sqrt(1.0D + d4 * d4);
            return new Complex(d5, d5 * d4);
        }
    }

    public static Complex log(Complex complex)
    {
        return new Complex(Math.log(abs(complex)), argument(complex));
    }

    public Complex multiply(double d)
    {
        re *= d;
        im *= d;
        return this;
    }

    public static Complex multiply(double d, Complex complex)
    {
        return new Complex(d * complex.re, d * complex.im);
    }

    public Complex multiply(Complex complex)
    {
        double d = re * complex.re - im * complex.im;
        im = re * complex.im + im * complex.re;
        re = d;
        return this;
    }

    public static Complex multiply(Complex complex, double d)
    {
        return new Complex(complex.re * d, complex.im * d);
    }

    public static Complex multiply(Complex complex, Complex complex1)
    {
        return new Complex(complex.re * complex1.re - complex.im * complex1.im, complex.re * complex1.im + complex.im * complex1.re);
    }

    public static Complex negate(Complex complex)
    {
        return new Complex(-complex.re, -complex.im);
    }

    public static Complex pow(Complex complex, double d)
    {
        double d1 = argument(complex);
        double d2 = abs(complex);
        if(d2 == 0.0D)
        {
            return complex;
        }
        else
        {
            double d3 = Math.pow(d2, d);
            return new Complex(d3 * Math.cos(d * d1), d3 * Math.sin(d * d1));
        }
    }

    public static Complex pow(Complex complex, Complex complex1)
    {
        Complex complex2 = new Complex();
        double d = abs(complex);
        if(d == 0.0D)
            return complex2;
        double d2 = argument(complex);
        complex2.im = complex1.im * Math.log(d) + complex1.re * d2;
        complex2 = exp(complex2);
        if(isInfinite(complex2))
        {
            return complex2;
        }
        else
        {
            double d1 = Math.abs(Math.pow(d, complex1.re) * Math.exp(-complex1.im * d2));
            return multiply(d1, complex2);
        }
    }

    public static Complex sin(Complex complex)
    {
        return new Complex(Math.sin(complex.re) * Sfun.cosh(complex.im), Math.cos(complex.re) * Sfun.sinh(complex.im));
    }

    public static Complex sqrt(Complex complex)
    {
        double d = abs(complex);
        if(d == 0.0D)
            return complex;
        if(Math.abs(complex.re) < Math.abs(complex.im))
        {
            if(complex.im >= 0.0D)
            {
                Complex complex5 = new Complex(complex.im, -complex.re);
                d = 0.5D * d;
                Complex complex1 = new Complex(l_c_proc_cs(complex5));
                d = Math.sqrt(d);
                complex.re = d * (complex1.re - complex1.im);
                complex.im = d * (complex1.re + complex1.im);
            }
            else
            {
                Complex complex6 = new Complex(-complex.im, complex.re);
                d = 0.5D * d;
                Complex complex2 = l_c_proc_cs(complex6);
                d = Math.sqrt(d);
                complex.re = d * (complex2.re + complex2.im);
                complex.im = d * (complex2.im - complex2.re);
            }
        }
        else
        if(complex.re < 0.0D)
        {
            complex.re = -complex.re;
            complex.im = -complex.im;
            Complex complex3 = new Complex(l_c_proc_cs(complex));
            d = Math.sqrt(d);
            if(complex.im > 0.0D)
            {
                complex.re = d * complex3.im;
                complex.im = -d * complex3.re;
            }
            else
            {
                complex.re = -d * complex3.im;
                complex.im = d * complex3.re;
            }
        }
        else
        {
            Complex complex4 = l_c_proc_cs(complex);
            d = Math.sqrt(d);
            complex.re = d * complex4.re;
            complex.im = d * complex4.im;
        }
        return new Complex(complex);
    }

    public Complex subtract(double d)
    {
        re -= d;
        return this;
    }

    public static Complex subtract(double d, Complex complex)
    {
        return new Complex(d - complex.re, -complex.im);
    }

    public Complex subtract(Complex complex)
    {
        re -= complex.re;
        im -= complex.im;
        return this;
    }

    public static Complex subtract(Complex complex, double d)
    {
        return new Complex(complex.re - d, complex.im);
    }

    public static Complex subtract(Complex complex, Complex complex1)
    {
        return new Complex(complex.re - complex1.re, complex.im - complex1.im);
    }

    public static Complex tan(Complex complex)
    {
        if(Math.abs(complex.im) > 8.1278104750000004D)
        {
            double d4 = complex.im >= 0.0D ? 1.0D : -1D;
            return new Complex(0.0D, d4);
        }
        double d = 2D * complex.re;
        double d1 = 2D * complex.im;
        if(Math.abs(d) > 4503599627370523D)
        {
            if(Math.abs(complex.im) < 1.5D)
                throw new ArithmeticException();
            if(Math.abs(complex.im) < 4.1391627360000003D)
                return new Complex(0.0D, Sfun.tanh(d1));
        }
        double d2 = Math.sin(d);
        double d3 = Math.cos(d) + Sfun.cosh(d1);
        if(d3 <= complex.re * d * 2.2204460492503E-016D * 2.2204460492503E-016D)
            throw new ArithmeticException();
        else
            return new Complex(d2 / d3, Sfun.sinh(d1) / d3);
    }

    public String toString()
    {
        if(im == 0.0D)
            return String.valueOf(re);
        if(re == 0.0D)
        {
            return String.valueOf(im) + suffix;
        }
        else
        {
            String s = im >= 0.0D ? "+" : "";
            return String.valueOf(re) + s + String.valueOf(im) + suffix;
        }
    }

    static double zabs1(Complex complex)
    {
        return Math.abs(complex.re) + Math.abs(complex.im);
    }

    public static final Complex INFINITY = new Complex((1.0D / 0.0D), (1.0D / 0.0D));
    public double re;
    public double im;
    public static String suffix = "i";
    private static final double EPSILON_LARGE = 2.2204460492503E-016D;
    private static final double XMAX = 4503599627370523D;
    private static final double YLARGE = 8.1278104750000004D;
    private static final double YBIG = 4.1391627360000003D;
    private static final double YMIN = 1.5D;
    private static final int NTERMS = 8;
    private static final double RMIN = 2.58095E-008D;

}
