// Decompiled by Jad v1.5.5.3. Copyright 1997-98 Pavel Kouznetsov.
// Jad home page:      http://web.unicom.com.cy/~kpd/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   ComplexMatrix.java

package VisualNumerics.math;


// Referenced classes of package VisualNumerics.math:
//            Complex, ComplexLU, ComplexQR, ComplexVector, 
//            MathException

public class ComplexMatrix
{

    public ComplexMatrix()
    {
    }

    static void CheckMatrix(Complex acomplex[][], int ai[], int ai1[])
        throws IllegalArgumentException
    {
        ai[0] = acomplex.length;
        ai1[0] = acomplex[0].length;
        for(int i = 1; i < ai[0]; i++)
            if(acomplex[i].length != ai1[0])
                throw new IllegalArgumentException("The lengths of the rows of the input matrix are not consistent.");

    }

    public static Complex[] QRsolve(Complex acomplex[][], Complex acomplex1[])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            i = ai[0];
            int j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int k = acomplex1.length;
        if(i != k)
            throw new IllegalArgumentException("The number of rows in the input matrix A is not equal to the number of elements in the input vector B.");
        try
        {
            ComplexQR complexqr = new ComplexQR(acomplex);
            return complexqr.solve(acomplex1);
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static Complex[][] add(Complex acomplex[][], Complex acomplex1[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i1;
        int j1;
//        try
//        {
            CheckMatrix(acomplex, ai, ai1);
            i1 = ai[0];
            j1 = ai1[0];
//        }
//        catch(IllegalArgumentException illegalargumentexception)
//        {
//            throw illegalargumentexception;
//        }
        int k;
        int l;
//        try
//        {
            CheckMatrix(acomplex1, ai, ai1);
            k = ai[0];
            l = ai1[0];
//        }
//        catch(IllegalArgumentException illegalargumentexception1)
//        {
//            throw illegalargumentexception1;
//        }
        if(i1 != k || j1 != l)
            throw new IllegalArgumentException("Matrices A and B must have similar dimensions.");
        Complex acomplex2[][] = new Complex[k][l];
        for(int i = 0; i < k; i++)
        {
            for(int j = 0; j < l; j++)
                acomplex2[i][j] = Complex.add(acomplex[i][j], acomplex1[i][j]);

        }

        return acomplex2;
    }

    public static Complex[][] adjoint(Complex acomplex[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int j;
        int k;
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            j = ai[0];
            k = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        Complex acomplex1[][] = new Complex[k][j];
        for(int i = 0; i < k; i++)
        {
            for(int l = 0; l < j; l++)
                acomplex1[i][l] = new Complex(Complex.conjugate(acomplex[l][i]));

        }

        return acomplex1;
    }

    public static Complex determinant(Complex acomplex[][])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            int i = ai[0];
            int j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        try
        {
            ComplexLU complexlu = new ComplexLU(acomplex);
            return complexlu.determinant();
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static double frobeniusNorm(Complex acomplex[][])
    {
        int i = acomplex.length;
        int j = acomplex[0].length;
        Complex acomplex1[] = new Complex[i];
        for(int k = 0; k < i; k++)
            acomplex1[k] = acomplex[k][0];

        double d = ComplexVector.twoNorm(acomplex1);
        for(int l = 1; l < j; l++)
        {
            for(int i1 = 0; i1 < i; i1++)
                acomplex1[i1] = acomplex[i1][l];

            double d1 = ComplexVector.twoNorm(acomplex1);
            d = hypt(d, d1);
        }

        return d;
    }

    private static double hypt(double d, double d1)
    {
        double d2 = Math.max(Math.abs(d), Math.abs(d1));
        if(d2 == 0.0D)
            return d2;
        double d3 = Math.min(Math.abs(d), Math.abs(d1)) / d2;
        d3 = Math.pow(d3, 2D);
        for(double d4 = 4D + d3; d4 != 4D; d4 = 4D + d3)
        {
            double d5 = d3 / d4;
            double d6 = 1.0D + 2D * d5;
            d2 *= d6;
            d3 = (d5 / d6) * (d5 / d6) * d3;
        }

        return d2;
    }

    public static double infinityNorm(Complex acomplex[][])
    {
        int i = acomplex.length;
        int j = acomplex[0].length;
        double d = 0.0D;
        for(int k = 0; k < i; k++)
        {
            double d1 = 0.0D;
            for(int l = 0; l < j; l++)
                d1 += Complex.abs(acomplex[k][l]);

            if(d1 > d)
                d = d1;
        }

        return d;
    }

    public static Complex[][] inverse(Complex acomplex[][])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            int i = ai[0];
            int j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        try
        {
            ComplexLU complexlu = new ComplexLU(acomplex);
            return complexlu.inverse();
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static Complex[] multiply(Complex acomplex[], Complex acomplex1[][])
        throws IllegalArgumentException
    {
        int k = acomplex.length;
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int l;
        int i1;
        try
        {
            CheckMatrix(acomplex1, ai, ai1);
            i1 = ai[0];
            l = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        if(k != i1)
            throw new IllegalArgumentException("The number of elements in the input vector is not equal to the number of rows in the input matrix.");
        Complex acomplex2[] = new Complex[l];
        for(int j = 0; j < l; j++)
        {
            acomplex2[j] = new Complex();
            for(int i = 0; i < k; i++)
            {
                Complex complex = Complex.multiply(acomplex[i], acomplex1[i][j]);
                acomplex2[j] = Complex.add(acomplex2[j], complex);
            }

        }

        return acomplex2;
    }

    public static Complex[] multiply(Complex acomplex[][], Complex acomplex1[])
        throws IllegalArgumentException
    {
        int k = acomplex1.length;
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int l;
        int i1;
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            l = ai[0];
            i1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        if(i1 != k)
            throw new IllegalArgumentException("The number of columns in the input matrix is not equal to the number of elements in the input vector.");
        Complex acomplex2[] = new Complex[l];
        for(int j = 0; j < l; j++)
        {
            acomplex2[j] = new Complex();
            for(int i = 0; i < k; i++)
            {
                Complex complex = Complex.multiply(acomplex[j][i], acomplex1[i]);
                acomplex2[j] = Complex.add(acomplex2[j], complex);
            }

        }

        return acomplex2;
    }

    public static Complex[][] multiply(Complex acomplex[][], Complex acomplex1[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int j1;
        int k1;
//        try
//        {
            CheckMatrix(acomplex, ai, ai1);
            j1 = ai[0];
            k1 = ai1[0];
//        }
//        catch(IllegalArgumentException illegalargumentexception)
//        {
//            throw illegalargumentexception;
//        }
        int l;
        int i1;
//        try
//        {
            CheckMatrix(acomplex1, ai, ai1);
            l = ai[0];
            i1 = ai1[0];
//        }
//        catch(IllegalArgumentException illegalargumentexception1)
//        {
//            throw illegalargumentexception1;
//        }
        if(k1 != l)
            throw new IllegalArgumentException("The number of columns in the input matrix A is not equal to the number of rows in the input matrix B.");
        Complex acomplex2[][] = new Complex[j1][i1];
        for(int i = 0; i < j1; i++)
        {
            for(int j = 0; j < i1; j++)
            {
                acomplex2[i][j] = new Complex();
                for(int k = 0; k < l; k++)
                {
                    Complex complex = Complex.multiply(acomplex[i][k], acomplex1[k][j]);
                    acomplex2[i][j] = Complex.add(acomplex2[i][j], complex);
                }

            }

        }

        return acomplex2;
    }

    public static double oneNorm(Complex acomplex[][])
    {
        int i = acomplex.length;
        int j = acomplex[0].length;
        double d = 0.0D;
        for(int k = 0; k < j; k++)
        {
            double d1 = 0.0D;
            for(int l = 0; l < i; l++)
                d1 += Complex.abs(acomplex[l][k]);

            if(d1 > d)
                d = d1;
        }

        return d;
    }

    public static Complex[] solve(Complex acomplex[][], Complex acomplex1[])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            i = ai[0];
            int j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int k = acomplex1.length;
        if(i != k)
            throw new IllegalArgumentException("The number of rows in the input matrix A is not equal to the number of elements in the input vector B.");
        try
        {
            ComplexLU complexlu = new ComplexLU(acomplex);
            return complexlu.solve(acomplex1);
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static Complex[][] subtract(Complex acomplex[][], Complex acomplex1[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i1;
        int j1;
//        try
//        {
            CheckMatrix(acomplex, ai, ai1);
            i1 = ai[0];
            j1 = ai1[0];
//        }
//        catch(IllegalArgumentException illegalargumentexception)
//        {
//            throw illegalargumentexception;
//        }
        int k;
        int l;
//        try
//        {
            CheckMatrix(acomplex1, ai, ai1);
            k = ai[0];
            l = ai1[0];
//        }
//        catch(IllegalArgumentException illegalargumentexception1)
//        {
//            throw illegalargumentexception1;
//        }
        if(i1 != k || j1 != l)
            throw new IllegalArgumentException("Matrices A and B must have similar dimensions.");
        Complex acomplex2[][] = new Complex[k][l];
        for(int i = 0; i < k; i++)
        {
            for(int j = 0; j < l; j++)
                acomplex2[i][j] = Complex.subtract(acomplex[i][j], acomplex1[i][j]);

        }

        return acomplex2;
    }

    public static Complex trace(Complex acomplex[][])
        throws MathException
    {
        Complex complex = new Complex(0.0D);
        if(acomplex.length != acomplex[0].length)
            throw new MathException("Matrix is not square.");
        for(int i = 0; i < acomplex.length; i++)
            complex.add(acomplex[i][i]);

        return complex;
    }

    public static Complex[][] transpose(Complex acomplex[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int j;
        int k;
        try
        {
            CheckMatrix(acomplex, ai, ai1);
            j = ai[0];
            k = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        Complex acomplex1[][] = new Complex[k][j];
        for(int i = 0; i < k; i++)
        {
            for(int l = 0; l < j; l++)
                acomplex1[i][l] = new Complex(acomplex[l][i]);

        }

        return acomplex1;
    }

    static Complex[][] zero(int i, int j)
    {
        Complex acomplex[][] = new Complex[i][j];
        for(int k = 0; k < i; k++)
        {
            for(int l = 0; l < j; l++)
                acomplex[k][l] = new Complex(0.0D, 0.0D);

        }

        return acomplex;
    }
}