// Decompiled by Jad v1.5.5.3. Copyright 1997-98 Pavel Kouznetsov.
// Jad home page:      http://web.unicom.com.cy/~kpd/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DoubleCholesky.java

package VisualNumerics.math;


// Referenced classes of package VisualNumerics.math:
//            BLAS, DoubleMatrix, DoubleVector, MathException

public class DoubleCholesky
{

    public DoubleCholesky(double ad[][])
        throws IllegalArgumentException, MathException
    {
        double ad1[][] = new double[8][129];
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        try
        {
            DoubleMatrix.CheckMatrix(ad, ai, ai1);
            n = ai[0];
            i = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int i5 = n;
        int j5 = i;
        if(!DoubleMatrix.IsSymmetric(ad))
            throw new MathException("Cholesky factorization requires a symmetric matrix.");
        fac = DoubleMatrix.copy(ad);
        acopy = new double[i5][j5];
        acopy = ad;
        for(int k5 = 0; k5 < n - 1; k5++)
        {
            for(int l5 = k5; l5 < n - 1; l5++)
                fac[l5 + 1][k5] = fac[k5][l5 + 1];

        }

        boolean flag = false;
        int l4 = n % 8;
        for(int i6 = 1; i6 <= n - l4; i6 += 8)
        {
            int j4 = (int)Math.min(129D, n - i6);
            if(fac[i6 - 1][i6 - 1] <= 0.0D)
            {
                int k = i6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 - 1][i6 - 1] = Math.sqrt(fac[i6 - 1][i6 - 1]);
            double d = 1.0D / fac[i6 - 1][i6 - 1];
            for(int j6 = 1; j6 <= j4; j6++)
            {
                fac[i6 - 1][(i6 + j6) - 1] *= d;
                ad1[0][j6 - 1] = -fac[i6 - 1][(i6 + j6) - 1];
            }

            for(int l6 = i6 + j4 + 1; l6 <= n; l6++)
                fac[i6 - 1][l6 - 1] *= d;

            for(int j7 = 1; j7 <= 7; j7++)
            {
                for(int l7 = j7; l7 <= n - i6; l7++)
                    fac[(i6 + j7) - 1][(i6 + l7) - 1] += fac[i6 - 1][(i6 + l7) - 1] * ad1[0][j7 - 1];

            }

            if(fac[i6][i6] <= 0.0D)
            {
                int l = i6 + 1;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6][i6] = Math.sqrt(fac[i6][i6]);
            double d1 = 1.0D / fac[i6][i6];
            for(int i8 = 2; i8 <= j4; i8++)
            {
                fac[i6][(i6 + i8) - 1] *= d1;
                ad1[1][i8 - 1] = -fac[i6][(i6 + i8) - 1];
            }

            for(int j8 = i6 + j4 + 1; j8 <= n; j8++)
                fac[i6][j8 - 1] *= d1;

            for(int k8 = 2; k8 <= 7; k8++)
            {
                for(int l8 = k8; l8 <= n - i6; l8++)
                    fac[(i6 + k8) - 1][(i6 + l8) - 1] += fac[i6][(i6 + l8) - 1] * ad1[1][k8 - 1];

            }

            if(fac[i6 + 1][i6 + 1] <= 0.0D)
            {
                int i1 = i6 + 2;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 + 1][i6 + 1] = Math.sqrt(fac[i6 + 1][i6 + 1]);
            double d2 = 1.0D / fac[i6 + 1][i6 + 1];
            for(int i9 = 3; i9 <= j4; i9++)
            {
                fac[i6 + 1][(i6 + i9) - 1] *= d2;
                ad1[2][i9 - 1] = -fac[i6 + 1][(i6 + i9) - 1];
            }

            for(int j9 = i6 + j4 + 1; j9 <= n; j9++)
                fac[i6 + 1][j9 - 1] *= d2;

            for(int k9 = 3; k9 <= 7; k9++)
            {
                for(int l9 = k9; l9 <= n - i6; l9++)
                    fac[(i6 + k9) - 1][(i6 + l9) - 1] += fac[i6 + 1][(i6 + l9) - 1] * ad1[2][k9 - 1];

            }

            if(fac[i6 + 2][i6 + 2] <= 0.0D)
            {
                int j1 = i6 + 3;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 + 2][i6 + 2] = Math.sqrt(fac[i6 + 2][i6 + 2]);
            double d3 = 1.0D / fac[i6 + 2][i6 + 2];
            for(int i10 = 4; i10 <= j4; i10++)
            {
                fac[i6 + 2][(i6 + i10) - 1] *= d3;
                ad1[3][i10 - 1] = -fac[i6 + 2][(i6 + i10) - 1];
            }

            for(int j10 = i6 + j4 + 1; j10 <= n; j10++)
                fac[i6 + 2][j10 - 1] *= d3;

            for(int k10 = 4; k10 <= 7; k10++)
            {
                for(int l10 = k10; l10 <= n - i6; l10++)
                    fac[(i6 + k10) - 1][(i6 + l10) - 1] += fac[i6 + 2][(i6 + l10) - 1] * ad1[3][k10 - 1];

            }

            if(fac[i6 + 3][i6 + 3] <= 0.0D)
            {
                int k1 = i6 + 4;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 + 3][i6 + 3] = Math.sqrt(fac[i6 + 3][i6 + 3]);
            double d4 = 1.0D / fac[i6 + 3][i6 + 3];
            for(int i11 = 5; i11 <= j4; i11++)
            {
                fac[i6 + 3][(i6 + i11) - 1] *= d4;
                ad1[4][i11 - 1] = -fac[i6 + 3][(i6 + i11) - 1];
            }

            for(int j11 = i6 + j4 + 1; j11 <= n; j11++)
                fac[i6 + 3][j11 - 1] *= d4;

            for(int k11 = 5; k11 <= 7; k11++)
            {
                for(int l11 = k11; l11 <= n - i6; l11++)
                    fac[(i6 + k11) - 1][(i6 + l11) - 1] += fac[i6 + 3][(i6 + l11) - 1] * ad1[4][k11 - 1];

            }

            if(fac[i6 + 4][i6 + 4] <= 0.0D)
            {
                int l1 = i6 + 5;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 + 4][i6 + 4] = Math.sqrt(fac[i6 + 4][i6 + 4]);
            double d5 = 1.0D / fac[i6 + 4][i6 + 4];
            for(int i12 = 6; i12 <= j4; i12++)
            {
                fac[i6 + 4][(i6 + i12) - 1] *= d5;
                ad1[5][i12 - 1] = -fac[i6 + 4][(i6 + i12) - 1];
            }

            for(int j12 = i6 + j4 + 1; j12 <= n; j12++)
                fac[i6 + 4][j12 - 1] *= d5;

            for(int k12 = 6; k12 <= 7; k12++)
            {
                for(int l12 = k12; l12 <= n - i6; l12++)
                    fac[(i6 + k12) - 1][(i6 + l12) - 1] += fac[i6 + 4][(i6 + l12) - 1] * ad1[5][k12 - 1];

            }

            if(fac[i6 + 5][i6 + 5] <= 0.0D)
            {
                int i2 = i6 + 6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 + 5][i6 + 5] = Math.sqrt(fac[i6 + 5][i6 + 5]);
            double d6 = 1.0D / fac[i6 + 5][i6 + 5];
            for(int i13 = 7; i13 <= j4; i13++)
            {
                fac[i6 + 5][(i6 + i13) - 1] *= d6;
                ad1[6][i13 - 1] = -fac[i6 + 5][(i6 + i13) - 1];
            }

            for(int j13 = i6 + j4 + 1; j13 <= n; j13++)
                fac[i6 + 5][j13 - 1] *= d6;

            for(int k13 = 7; k13 <= n - i6; k13++)
                fac[i6 + 6][(i6 + k13) - 1] += fac[i6 + 5][(i6 + k13) - 1] * ad1[6][6];

            if(fac[i6 + 6][i6 + 6] <= 0.0D)
            {
                int j2 = i6 + 7;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[i6 + 6][i6 + 6] = Math.sqrt(fac[i6 + 6][i6 + 6]);
            double d7 = 1.0D / fac[i6 + 6][i6 + 6];
            for(int l13 = 8; l13 <= j4; l13++)
            {
                fac[i6 + 6][(i6 + l13) - 1] *= d7;
                ad1[7][l13 - 1] = -fac[i6 + 6][(i6 + l13) - 1];
            }

            for(int i14 = i6 + j4 + 1; i14 <= n; i14++)
                fac[i6 + 6][i14 - 1] *= d7;

            for(int j14 = 8; j14 <= j4; j14++)
            {
                for(int k14 = j14; k14 <= n - i6; k14++)
                    fac[(i6 + j14) - 1][(i6 + k14) - 1] += fac[i6 - 1][(i6 + k14) - 1] * ad1[0][j14 - 1] + fac[i6][(i6 + k14) - 1] * ad1[1][j14 - 1] + fac[i6 + 1][(i6 + k14) - 1] * ad1[2][j14 - 1] + fac[i6 + 2][(i6 + k14) - 1] * ad1[3][j14 - 1] + fac[i6 + 3][(i6 + k14) - 1] * ad1[4][j14 - 1] + fac[i6 + 4][(i6 + k14) - 1] * ad1[5][j14 - 1] + fac[i6 + 5][(i6 + k14) - 1] * ad1[6][j14 - 1] + fac[i6 + 6][(i6 + k14) - 1] * ad1[7][j14 - 1];

            }

            for(int l14 = i6 + 129 + 1; l14 <= n; l14 += 129)
            {
                int j = l14 - 1;
                int k4 = (int)Math.min(n - j, 129D);
                for(int i15 = 0; i15 <= 7; i15++)
                {
                    for(int j15 = 1; j15 <= k4; j15++)
                        ad1[i15][j15 - 1] = -fac[(i6 + i15) - 1][(j + j15) - 1];

                }

                for(int k15 = 1; k15 <= k4; k15++)
                {
                    for(int l15 = k15; l15 <= n - j; l15++)
                        fac[(j + k15) - 1][(j + l15) - 1] += fac[i6 - 1][(j + l15) - 1] * ad1[0][k15 - 1] + fac[i6][(j + l15) - 1] * ad1[1][k15 - 1] + fac[i6 + 1][(j + l15) - 1] * ad1[2][k15 - 1] + fac[i6 + 2][(j + l15) - 1] * ad1[3][k15 - 1] + fac[i6 + 3][(j + l15) - 1] * ad1[4][k15 - 1] + fac[i6 + 4][(j + l15) - 1] * ad1[5][k15 - 1] + fac[i6 + 5][(j + l15) - 1] * ad1[6][k15 - 1] + fac[i6 + 6][(j + l15) - 1] * ad1[7][k15 - 1];

                }

            }

        }

        int k6 = (n - l4) + 1;
        if(l4 == 7)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int k2 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
            double d8 = 1.0D / fac[k6 - 1][k6 - 1];
            fac[k6 - 1][k6] *= d8;
            fac[k6 - 1][k6 + 1] *= d8;
            fac[k6 - 1][k6 + 2] *= d8;
            fac[k6 - 1][k6 + 3] *= d8;
            fac[k6 - 1][k6 + 4] *= d8;
            fac[k6 - 1][k6 + 5] *= d8;
            fac[k6][k6] -= fac[k6 - 1][k6] * fac[k6 - 1][k6];
            fac[k6][k6 + 1] += -fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6];
            fac[k6][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6];
            fac[k6][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6];
            fac[k6][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6];
            fac[k6][k6 + 5] += -fac[k6 - 1][k6 + 5] * fac[k6 - 1][k6];
            fac[k6 + 1][k6 + 1] -= fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 5] += -fac[k6 - 1][k6 + 5] * fac[k6 - 1][k6 + 1];
            fac[k6 + 2][k6 + 2] -= fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 2];
            fac[k6 + 2][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 2];
            fac[k6 + 2][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 2];
            fac[k6 + 2][k6 + 5] += -fac[k6 - 1][k6 + 5] * fac[k6 - 1][k6 + 2];
            fac[k6 + 3][k6 + 3] -= fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 3];
            fac[k6 + 3][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 3];
            fac[k6 + 3][k6 + 5] += -fac[k6 - 1][k6 + 5] * fac[k6 - 1][k6 + 3];
            fac[k6 + 4][k6 + 4] -= fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 4];
            fac[k6 + 4][k6 + 5] += -fac[k6 - 1][k6 + 5] * fac[k6 - 1][k6 + 4];
            fac[k6 + 5][k6 + 5] -= fac[k6 - 1][k6 + 5] * fac[k6 - 1][k6 + 5];
            k6++;
            l4--;
        }
        if(l4 == 6)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int l2 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
            double d9 = 1.0D / fac[k6 - 1][k6 - 1];
            fac[k6 - 1][k6] *= d9;
            fac[k6 - 1][k6 + 1] *= d9;
            fac[k6 - 1][k6 + 2] *= d9;
            fac[k6 - 1][k6 + 3] *= d9;
            fac[k6 - 1][k6 + 4] *= d9;
            fac[k6][k6] -= fac[k6 - 1][k6] * fac[k6 - 1][k6];
            fac[k6][k6 + 1] += -fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6];
            fac[k6][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6];
            fac[k6][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6];
            fac[k6][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6];
            fac[k6 + 1][k6 + 1] -= fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 1];
            fac[k6 + 2][k6 + 2] -= fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 2];
            fac[k6 + 2][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 2];
            fac[k6 + 2][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 2];
            fac[k6 + 3][k6 + 3] -= fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 3];
            fac[k6 + 3][k6 + 4] += -fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 3];
            fac[k6 + 4][k6 + 4] -= fac[k6 - 1][k6 + 4] * fac[k6 - 1][k6 + 4];
            k6++;
            l4--;
        }
        if(l4 == 5)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int i3 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
            double d10 = 1.0D / fac[k6 - 1][k6 - 1];
            fac[k6 - 1][k6] *= d10;
            fac[k6 - 1][k6 + 1] *= d10;
            fac[k6 - 1][k6 + 2] *= d10;
            fac[k6 - 1][k6 + 3] *= d10;
            fac[k6][k6] -= fac[k6 - 1][k6] * fac[k6 - 1][k6];
            fac[k6][k6 + 1] += -fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6];
            fac[k6][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6];
            fac[k6][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6];
            fac[k6 + 1][k6 + 1] -= fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 1];
            fac[k6 + 2][k6 + 2] -= fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 2];
            fac[k6 + 2][k6 + 3] += -fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 2];
            fac[k6 + 3][k6 + 3] -= fac[k6 - 1][k6 + 3] * fac[k6 - 1][k6 + 3];
            k6++;
            l4--;
        }
        if(l4 == 4)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int j3 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
            double d11 = 1.0D / fac[k6 - 1][k6 - 1];
            fac[k6 - 1][k6] *= d11;
            fac[k6 - 1][k6 + 1] *= d11;
            fac[k6 - 1][k6 + 2] *= d11;
            fac[k6][k6] -= fac[k6 - 1][k6] * fac[k6 - 1][k6];
            fac[k6][k6 + 1] += -fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6];
            fac[k6][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6];
            fac[k6 + 1][k6 + 1] -= fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6 + 1];
            fac[k6 + 1][k6 + 2] += -fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 1];
            fac[k6 + 2][k6 + 2] -= fac[k6 - 1][k6 + 2] * fac[k6 - 1][k6 + 2];
            k6++;
            l4--;
        }
        if(l4 == 3)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int k3 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
            double d12 = 1.0D / fac[k6 - 1][k6 - 1];
            fac[k6 - 1][k6] *= d12;
            fac[k6 - 1][k6 + 1] *= d12;
            fac[k6][k6] -= fac[k6 - 1][k6] * fac[k6 - 1][k6];
            fac[k6][k6 + 1] += -fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6];
            fac[k6 + 1][k6 + 1] -= fac[k6 - 1][k6 + 1] * fac[k6 - 1][k6 + 1];
            k6++;
            l4--;
        }
        if(l4 == 2)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int l3 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
            double d13 = 1.0D / fac[k6 - 1][k6 - 1];
            fac[k6 - 1][k6] *= d13;
            fac[k6][k6] -= fac[k6 - 1][k6] * fac[k6 - 1][k6];
            k6++;
            l4--;
        }
        if(l4 == 1)
        {
            if(fac[k6 - 1][k6 - 1] <= 0.0D)
            {
                int i4 = k6;
                throw new MathException("Matrix is not positive definite.");
            }
            fac[k6 - 1][k6 - 1] = Math.sqrt(fac[k6 - 1][k6 - 1]);
        }
        for(int i7 = 0; i7 < n - 1; i7++)
        {
            for(int k7 = i7; k7 < n - 1; k7++)
                fac[k7 + 1][i7] = fac[i7][k7 + 1];

        }

    }

    public double[][] R()
    {
        return fac;
    }

    public double condition()
        throws MathException
    {
        cond = 1.0D;
        double d = BLAS.dnr1rr(n, n, acopy);
        double d2 = 1.0D;
        double ad[] = new double[n];
        for(int i = 0; i < n; i++)
        {
            if(ad[i] != 0.0D)
            {
                d2 = Math.abs(d2);
                if(-ad[i] < 0.0D)
                    d2 = -d2;
            }
            if(Math.abs(d2 - ad[i]) > fac[i][i])
            {
                double d3 = fac[i][i] / Math.abs(d2 - ad[i]);
                BLAS.dscal(n, d3, ad, 0, 1);
                d2 *= d3;
            }
            double d6 = d2 - ad[i];
            double d7 = -d2 - ad[i];
            double d4 = Math.abs(d6);
            double d8 = Math.abs(d7);
            if(Math.abs(fac[i][i]) > 2.2250738585071999E-308D)
            {
                d6 /= fac[i][i];
                d7 /= fac[i][i];
            }
            int j1 = i + 1;
            if(j1 < n)
            {
                for(int i1 = i + 1; i1 < n; i1++)
                    d8 += Math.abs(ad[i1] + d7 * fac[i][i1]);

                for(int k1 = 1; k1 < n - i; k1++)
                    ad[k1 + i] += d6 * fac[i][k1 + i];

                for(int j2 = 1; j2 < n - i; j2++)
                    d4 += Math.abs(ad[j2 + i]);

                if(d4 < d8)
                {
                    double d9 = d7 - d6;
                    d6 = d7;
                    for(int k2 = 1; k2 < n - i; k2++)
                        ad[k2 + i] += d9 * fac[i][k2 + i];

                }
            }
            ad[i] = d6;
        }

        double d5 = 1.0D / BLAS.dasum(n, ad, 0, 1);
        BLAS.dscal(n, d5, ad, 0, 1);
        for(int j = n - 1; j >= 0; j--)
        {
            if(Math.abs(ad[j]) > fac[j][j])
            {
                d5 = fac[j][j] / Math.abs(ad[j]);
                BLAS.dscal(n, d5, ad, 0, 1);
            }
            if(Math.abs(fac[j][j]) > 2.2250738585071999E-308D)
                ad[j] /= fac[j][j];
            double d10 = -ad[j];
            for(int l1 = 0; l1 < j; l1++)
                ad[l1] -= fac[l1][j] * ad[j];

        }

        d5 = 1.0D / BLAS.dasum(n, ad, 0, 1);
        BLAS.dscal(n, d5, ad, 0, 1);
        double d1 = 1.0D;
        for(int k = 0; k < n; k++)
        {
            double d12 = 0.0D;
            for(int l2 = 0; l2 < k; l2++)
                d12 += fac[l2][k] * ad[l2];

            ad[k] -= d12;
            if(Math.abs(ad[k]) > fac[k][k])
            {
                d5 = fac[k][k] / Math.abs(ad[k]);
                BLAS.dscal(n, d5, ad, 0, 1);
                d1 *= d5;
            }
            if(Math.abs(fac[k][k]) > 2.2250738585071999E-308D)
                ad[k] /= fac[k][k];
        }

        d5 = 1.0D / BLAS.dasum(n, ad, 0, 1);
        BLAS.dscal(n, d5, ad, 0, 1);
        d1 *= d5;
        for(int l = n - 1; l >= 0; l--)
        {
            if(Math.abs(ad[l]) > fac[l][l])
            {
                d5 = fac[l][l] / Math.abs(ad[l]);
                BLAS.dscal(n, d5, ad, 0, 1);
                d1 *= d5;
            }
            if(Math.abs(fac[l][l]) > 2.2250738585071999E-308D)
                ad[l] /= fac[l][l];
            double d11 = -ad[l];
            for(int i2 = 0; i2 < l; i2++)
                ad[i2] -= fac[i2][l] * ad[l];

        }

        d5 = 1.0D / BLAS.dasum(n, ad, 0, 1);
        BLAS.dscal(n, d5, ad, 0, 1);
        d1 *= d5;
        if(d != 0.0D)
            cond = d1 / d;
        if(cond <= 2.2204460492503E-016D)
            throw new MathException("The matrix is algorithmically singular.");
        else
            return cond;
    }

    public double determinant()
    {
        double d = 1.0D;
        for(int i = 0; i < n; i++)
            d *= fac[i][i];

        return d * d;
    }

    public double[][] inverse()
        throws MathException
    {
        double ad[][] = DoubleMatrix.copy(fac);
        for(int j = 0; j < n; j++)
        {
            for(int k = 0; k < j; k++)
                ad[j][k] = 0.0D;

        }

        for(int l = 0; l < n; l++)
        {
            int i = l;
            if(Math.abs(ad[l][l]) <= 2.2250738585071999E-308D)
                throw new MathException("The matrix to be inverted is singular.");
            ad[l][l] = 1.0D / ad[l][l];
            double d = -ad[l][l];
            for(int i1 = 0; i1 < l; i1++)
                ad[i1][l] *= d;

            if(l < n - 1)
            {
                for(int k1 = 0; k1 < n - l - 1; k1++)
                {
                    for(int j2 = 0; j2 < l; j2++)
                        ad[j2][l + 1 + k1] += ad[j2][l] * ad[l][l + 1 + k1];

                }

                for(int k2 = 0; k2 < n - l - 1; k2++)
                    ad[l][l + 1 + k2] *= ad[l][l];

            }
        }

        for(int j1 = 0; j1 < n; j1++)
        {
            for(int l1 = 0; l1 < j1; l1++)
            {
                for(int l2 = 0; l2 < l1 + 1; l2++)
                    ad[l2][l1] += ad[l2][j1] * ad[l1][j1];

            }

            double d1 = ad[j1][j1];
            for(int i3 = 0; i3 < j1 + 1; i3++)
                ad[i3][j1] *= d1;

        }

        for(int i2 = 0; i2 < n; i2++)
        {
            for(int j3 = i2; j3 < n - 1; j3++)
                ad[j3 + 1][i2] = ad[i2][j3 + 1];

        }

        return ad;
    }

    public double[] solve(double ad[])
        throws MathException
    {
        for(int i = 0; i < n; i++)
            if(fac[i][i] == 0.0D)
                throw new MathException("The input triangular matrix is singular.");

        double ad1[] = DoubleVector.copy(ad);
        for(int j = 0; j < n; j++)
        {
            double d = 0.0D;
            for(int k = 0; k < j; k++)
                d += fac[j][k] * ad1[k];

            ad1[j] -= d;
            ad1[j] /= fac[j][j];
        }

        for(int l = n - 1; l >= 0; l--)
        {
            double d1 = 0.0D;
            if(l < n - 1)
            {
                for(int i1 = l + 1; i1 < n; i1++)
                    d1 += fac[l][i1] * ad1[i1];

            }
            ad1[l] -= d1;
            ad1[l] /= fac[l][l];
        }

        return ad1;
    }

    private double fac[][];
    private double cond;
    private double acopy[][];
    private int n;
    private static final double SMALLEST = 2.2250738585071999E-308D;
    private static final double LARGEST = 1.7976931348622999E+308D;
    private static final double EPSILON_LARGE = 2.2204460492503E-016D;
    private static final int NB = 129;
}
