// Decompiled by Jad v1.5.5.3. Copyright 1997-98 Pavel Kouznetsov.
// Jad home page:      http://web.unicom.com.cy/~kpd/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DoubleLU.java

package VisualNumerics.math;


// Referenced classes of package VisualNumerics.math:
//            BLAS, DoubleMatrix, MathException

public class DoubleLU
{

    public DoubleLU(double ad[][])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int k1;
        try
        {
            DoubleMatrix.CheckMatrix(ad, ai, ai1);
            k1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        acopy = ad;
        factor = new double[k1][k1];
        ipvt = new int[k1];
        info = new int[1];
        for(int i = 0; i < k1; i++)
            System.arraycopy(ad[i], 0, factor[i], 0, k1);

        info[0] = 0;
        int j1 = k1 - 1;
        if(j1 >= 1)
        {
            for(int k = 0; k < j1; k++)
            {
                int l = k + 1;
                int i1 = BLAS.idamax(k1 - k, factor[k], k, 1) + k;
                ipvt[k] = i1;
                if(factor[k][i1] == 0.0D)
                {
                    info[0] = k;
                }
                else
                {
                    if(i1 != k)
                    {
                        double d = factor[k][i1];
                        factor[k][i1] = factor[k][k];
                        factor[k][k] = d;
                    }
                    double d1 = -1D / factor[k][k];
                    BLAS.dscal(k1 - k - 1, d1, factor[k], l, 1);
                    for(int j = l; j < k1; j++)
                    {
                        double d2 = factor[j][i1];
                        if(i1 != k)
                        {
                            factor[j][i1] = factor[j][k];
                            factor[j][k] = d2;
                        }
                        BLAS.daxpy(k1 - k - 1, d2, factor[k], l, 1, factor[j], l, 1);
                    }

                }
            }

        }
        ipvt[j1] = j1;
        if(factor[j1][j1] == 0.0D)
            info[0] = j1;
        if(info[0] != 0)
            throw new MathException("The input matrix is singular. Some of the diagonal elements of the upper triangular matrix U of the LU factorization are close to zero.");
        else
            return;
    }

    public double condition()
    {
        int i = acopy[0].length;
        double d13 = 1.0D;
        double d = BLAS.dnr1rr(i, i, acopy);
        double d2 = 1.0D;
        double ad1[] = new double[i];
        double ad[] = new double[i];
        for(int j = 0; j < i; j++)
        {
            if(ad1[j] != 0.0D)
            {
                d2 = Math.abs(d2);
                if(-ad1[j] < 0.0D)
                    d2 = -d2;
            }
            if(Math.abs(d2 - ad1[j]) > Math.abs(factor[j][j]))
            {
                double d3 = Math.abs(factor[j][j]) / Math.abs(d2 - ad1[j]);
                BLAS.dscal(i, d3, ad1, 0, 1);
                d2 = d3 * d2;
            }
            double d6 = d2 - ad1[j];
            double d7 = -d2 - ad1[j];
            double d4 = Math.abs(d6);
            double d8 = Math.abs(d7);
            if(factor[j][j] == 0.0D)
            {
                d6 = 1.0D;
                d7 = 1.0D;
            }
            else
            {
                d6 /= factor[j][j];
                d7 /= factor[j][j];
            }
            int k1 = j + 1;
            if(k1 < i)
            {
                for(int j1 = k1; j1 < i; j1++)
                {
                    d8 += Math.abs(ad1[j1] + d7 * factor[j][j1]);
                    ad1[j1] = ad1[j1] + d6 * factor[j][j1];
                    d4 += Math.abs(ad1[j1]);
                }

                if(d4 < d8)
                {
                    double d9 = d7 - d6;
                    d6 = d7;
                    int i2 = k1;
                    System.arraycopy(factor[j], i2, ad, 0, (i - i2) + 1);
                    BLAS.daxpy(i - 1 - j, d9, ad, 0, 1, ad1, k1, 1);
                }
            }
            ad1[j] = d6;
        }

        double d5 = 1.0D / BLAS.dasum(i, ad1, 0, 1);
        BLAS.dscal(i, d5, ad1, 0, 1);
        for(int k = i - 1; k >= 0; k--)
        {
            if(k < i - 1)
            {
                int j2 = 0;
                for(int i3 = 0; i3 < i; i3++)
                {
                    ad[i3] = factor[j2][k];
                    j2++;
                }

                ad1[k] = ad1[k] + BLAS.ddot(i - 1 - k, ad, k + 1, 1, ad1, k + 1, 1);
            }
            if(Math.abs(ad1[k]) > 1.0D)
            {
                d5 = 1.0D / Math.abs(ad1[k]);
                BLAS.dscal(i, d5, ad1, 0, 1);
            }
            int j3 = ipvt[k];
            double d10 = ad1[j3];
            ad1[j3] = ad1[k];
            ad1[k] = d10;
        }

        d5 = 1.0D / BLAS.dasum(i, ad1, 0, 1);
        BLAS.dscal(i, d5, ad1, 0, 1);
        double d1 = 1.0D;
        for(int l = 0; l < i; l++)
        {
            int k3 = ipvt[l];
            double d11 = ad1[k3];
            ad1[k3] = ad1[l];
            ad1[l] = d11;
            if(l < i - 1)
            {
                int l1 = l + 1;
                int k2 = 0;
                for(int l3 = 0; l3 < i; l3++)
                {
                    ad[l3] = factor[k2][l];
                    k2++;
                }

                BLAS.daxpy(i - 1 - l, d11, ad, l1, 1, ad1, l1, 1);
            }
            if(Math.abs(ad1[l]) > 1.0D)
            {
                d5 = 1.0D / Math.abs(ad1[l]);
                BLAS.dscal(i, d5, ad1, 0, 1);
                d1 = d5 * d1;
            }
        }

        d5 = 1.0D / BLAS.dasum(i, ad1, 0, 1);
        BLAS.dscal(i, d5, ad1, 0, 1);
        d1 = d5 * d1;
        for(int i1 = i - 1; i1 >= 0; i1--)
        {
            if(Math.abs(ad1[i1]) > Math.abs(factor[i1][i1]))
            {
                d5 = Math.abs(factor[i1][i1]) / Math.abs(ad1[i1]);
                BLAS.dscal(i, d5, ad1, 0, 1);
                d1 = d5 * d1;
            }
            if(factor[i1][i1] == 0.0D)
                ad1[i1] = 1.0D;
            else
                ad1[i1] = ad1[i1] / factor[i1][i1];
            double d12 = -ad1[i1];
            int l2 = 0;
            for(int i4 = 0; i4 < i; i4++)
            {
                ad[i4] = factor[l2][i1];
                l2++;
            }

            BLAS.daxpy(i1, d12, ad, 0, 1, ad1, 0, 1);
        }

        d5 = 1.0D / BLAS.dasum(i, ad1, 0, 1);
        BLAS.dscal(i, d5, ad1, 0, 1);
        d1 = d5 * d1;
        if(d != 0.0D)
            d13 = d1 / d;
        return d13;
    }

    public double determinant()
    {
        double d = 1.0D;
        double d1 = 1.0D;
        int k = factor.length;
        for(int i = 0; i < k; i++)
            d *= factor[i][i];

        for(int j = 0; j < k; j++)
            if(ipvt[j] > j)
                d1 *= -1D;

        d *= d1;
        return d;
    }

    public double[][] inverse()
    {
        int j = acopy[0].length;
        double ad[] = new double[j];
        double ad1[][] = new double[j][j];
        for(int i = 0; i < j; i++)
        {
            ad[i] = 1.0D;
            ad1[i] = solve(ad);
            ad[i] = 0.0D;
        }

        ad1 = DoubleMatrix.transpose(ad1);
        return ad1;
    }

    public int[] ipvt()
    {
        return ipvt;
    }

    public double[] solve(double ad[])
    {
        boolean flag = true;
        int j2 = ad.length;
        double ad1[] = new double[j2];
        System.arraycopy(ad, 0, ad1, 0, j2);
        int i2 = j2 - 1;
        if(!flag)
        {
            if(i2 >= 1)
            {
                for(int i = 0; i < i2; i++)
                {
                    int i1 = i + 1;
                    int k1 = ipvt[i];
                    double d = ad1[k1];
                    if(k1 != i)
                    {
                        ad1[k1] = ad1[i];
                        ad1[i] = d;
                    }
                    BLAS.daxpy(i2 - i, d, factor[i], i1, 1, ad1, i1, 1);
                }

            }
            for(int j = i2; j >= 0; j--)
            {
                ad1[j] = ad1[j] / factor[j][j];
                double d1 = -ad1[j];
                BLAS.daxpy(j, d1, factor[j], 0, 1, ad1, 0, 1);
            }

        }
        else
        {
            for(int k = 0; k < j2; k++)
            {
                double d2 = BLAS.ddot(k, factor[k], 0, 1, ad1, 0, 1);
                ad1[k] = (ad1[k] - d2) / factor[k][k];
            }

            if(i2 >= 1)
            {
                int j1 = i2;
                for(int l = i2 - 1; l >= 0; l--)
                {
                    ad1[l] = ad1[l] + BLAS.ddot(i2 - l, factor[l], j1, 1, ad1, j1, 1);
                    j1 = l;
                    int l1 = ipvt[l];
                    if(l1 != l)
                    {
                        double d3 = ad1[l1];
                        ad1[l1] = ad1[l];
                        ad1[l] = d3;
                    }
                }

            }
        }
        return ad1;
    }

    private double factor[][];
    private double acopy[][];
    private int ipvt[];
    private int info[];
    private static final double EPSILON_LARGE = 2.2204460492503E-016D;
}
