// Decompiled by Jad v1.5.5.3. Copyright 1997-98 Pavel Kouznetsov.
// Jad home page:      http://web.unicom.com.cy/~kpd/jad.html
// Decompiler options: packimports(3) 
// Source File Name:   DoubleMatrix.java

package VisualNumerics.math;


// Referenced classes of package VisualNumerics.math:
//            DoubleLU, DoubleQR, DoubleVector, MathException

public class DoubleMatrix
{

    public DoubleMatrix()
    {
    }

    static void CheckMatrix(double ad[][], int ai[], int ai1[])
        throws IllegalArgumentException
    {
        ai[0] = ad.length;
        ai1[0] = ad[0].length;
        for(int i = 1; i < ai[0]; i++)
            if(ad[i].length != ai1[0])
                throw new IllegalArgumentException("The lengths of the rows of the input matrix are not consistent.");

    }

    static boolean IsSymmetric(double ad[][])
    {
        int i = ad.length;
        int j = ad[0].length;
        if(i != j)
            return false;
        for(int k = 1; k < i; k++)
        {
            for(int l = 0; l < k; l++)
                if(ad[k][l] != ad[l][k])
                    return false;

        }

        return true;
    }

    public static double[] QRsolve(double ad[][], double ad1[])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        try
        {
            CheckMatrix(ad, ai, ai1);
            i = ai[0];
            int j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int k = ad1.length;
        if(i != k)
            throw new IllegalArgumentException("The number of rows in the input matrix A is not equal to the number of elements in the input vector B.");
        try
        {
            DoubleQR doubleqr = new DoubleQR(ad);
            return doubleqr.solve(ad1);
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static double[][] add(double ad[][], double ad1[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i1;
        int j1;
        try
        {
            CheckMatrix(ad, ai, ai1);
            i1 = ai[0];
            j1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int k;
        int l;
        try
        {
            CheckMatrix(ad1, ai, ai1);
            k = ai[0];
            l = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        if(i1 != k || j1 != l)
            throw new IllegalArgumentException("Matrices A and B must have similar dimensions.");
        double ad2[][] = new double[k][l];
        for(int i = 0; i < k; i++)
        {
            for(int j = 0; j < l; j++)
                ad2[i][j] = ad[i][j] + ad1[i][j];

        }

        return ad2;
    }

    static double[][] copy(double ad[][])
    {
        int i = ad.length;
        int j = ad[0].length;
        double ad1[][] = new double[i][j];
        for(int k = 0; k < i; k++)
            System.arraycopy(ad[k], 0, ad1[k], 0, j);

        return ad1;
    }

    public static double determinant(double ad[][])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        int j;
        try
        {
            CheckMatrix(ad, ai, ai1);
            i = ai[0];
            j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        if(j != i)
            throw new IllegalArgumentException("The matrix is not square.");
        try
        {
            DoubleLU doublelu = new DoubleLU(ad);
            return doublelu.determinant();
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static double frobeniusNorm(double ad[][])
    {
        int i = ad.length;
        int j = ad[0].length;
        double ad1[] = new double[i];
        for(int k = 0; k < i; k++)
            ad1[k] = ad[k][0];

        double d = DoubleVector.twoNorm(ad1);
        for(int l = 1; l < j; l++)
        {
            for(int i1 = 0; i1 < i; i1++)
                ad1[i1] = ad[i1][l];

            double d1 = DoubleVector.twoNorm(ad1);
            d = hypt(d, d1);
        }

        return d;
    }

    private static double hypt(double d, double d1)
    {
        double d2 = Math.max(Math.abs(d), Math.abs(d1));
        if(d2 == 0.0D)
            return d2;
        double d3 = Math.min(Math.abs(d), Math.abs(d1)) / d2;
        d3 = Math.pow(d3, 2D);
        for(double d4 = 4D + d3; d4 != 4D; d4 = 4D + d3)
        {
            double d5 = d3 / d4;
            double d6 = 1.0D + 2D * d5;
            d2 *= d6;
            d3 = (d5 / d6) * (d5 / d6) * d3;
        }

        return d2;
    }

    public static double infinityNorm(double ad[][])
    {
        int i = ad.length;
        int j = ad[0].length;
        double d = 0.0D;
        for(int k = 0; k < i; k++)
        {
            double d1 = 0.0D;
            for(int l = 0; l < j; l++)
                d1 += Math.abs(ad[k][l]);

            if(d1 > d)
                d = d1;
        }

        return d;
    }

    public static double[][] inverse(double ad[][])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        int j;
        try
        {
            CheckMatrix(ad, ai, ai1);
            i = ai[0];
            j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        if(j != i)
            throw new IllegalArgumentException("The matrix is not square.");
        try
        {
            DoubleLU doublelu = new DoubleLU(ad);
            return doublelu.inverse();
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static double[] multiply(double ad[], double ad1[][])
        throws IllegalArgumentException
    {
        int k = ad.length;
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int l;
        int i1;
        try
        {
            CheckMatrix(ad1, ai, ai1);
            i1 = ai[0];
            l = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        if(k != i1)
            throw new IllegalArgumentException("The number of elements in the input vector is not equal to the number of rows in the input matrix.");
        double ad2[] = new double[l];
        for(int j = 0; j < l; j++)
        {
            for(int i = 0; i < k; i++)
                ad2[j] += ad[i] * ad1[i][j];

        }

        return ad2;
    }

    public static double[] multiply(double ad[][], double ad1[])
        throws IllegalArgumentException
    {
        int k = ad1.length;
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int l;
        int i1;
        try
        {
            CheckMatrix(ad, ai, ai1);
            l = ai[0];
            i1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        if(i1 != k)
            throw new IllegalArgumentException("The number of columns in the input matrix is not equal to the number of elements in the input vector.");
        double ad2[] = new double[l];
        for(int j = 0; j < l; j++)
        {
            for(int i = 0; i < k; i++)
                ad2[j] += ad[j][i] * ad1[i];

        }

        return ad2;
    }

    public static double[][] multiply(double ad[][], double ad1[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int j1;
        int k1;
        try
        {
            CheckMatrix(ad, ai, ai1);
            j1 = ai[0];
            k1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int l;
        int i1;
        try
        {
            CheckMatrix(ad1, ai, ai1);
            l = ai[0];
            i1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        if(k1 != l)
            throw new IllegalArgumentException("The number of columns in the input matrix A is not equal to the number of rows in the input matrix B.");
        double ad2[][] = new double[j1][i1];
        for(int i = 0; i < j1; i++)
        {
            for(int j = 0; j < i1; j++)
            {
                for(int k = 0; k < l; k++)
                    ad2[i][j] += ad[i][k] * ad1[k][j];

            }

        }

        return ad2;
    }

    public static double oneNorm(double ad[][])
    {
        int i = ad.length;
        int j = ad[0].length;
        double d = 0.0D;
        for(int k = 0; k < j; k++)
        {
            double d1 = 0.0D;
            for(int l = 0; l < i; l++)
                d1 += Math.abs(ad[l][k]);

            if(d1 > d)
                d = d1;
        }

        return d;
    }

    public static double[] solve(double ad[][], double ad1[])
        throws IllegalArgumentException, MathException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i;
        try
        {
            CheckMatrix(ad, ai, ai1);
            i = ai[0];
            int j = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int k = ad1.length;
        if(i != k)
            throw new IllegalArgumentException("The number of rows in the input matrix A is not equal to the number of elements in the input vector B.");
        try
        {
            DoubleLU doublelu = new DoubleLU(ad);
            return doublelu.solve(ad1);
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        catch(MathException mathexception)
        {
            throw mathexception;
        }
    }

    public static double[][] subtract(double ad[][], double ad1[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int i1;
        int j1;
        try
        {
            CheckMatrix(ad, ai, ai1);
            i1 = ai[0];
            j1 = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        int k;
        int l;
        try
        {
            CheckMatrix(ad1, ai, ai1);
            k = ai[0];
            l = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception1)
        {
            throw illegalargumentexception1;
        }
        if(i1 != k || j1 != l)
            throw new IllegalArgumentException("Matrices A and B must have similar dimensions.");
        double ad2[][] = new double[k][l];
        for(int i = 0; i < k; i++)
        {
            for(int j = 0; j < l; j++)
                ad2[i][j] = ad[i][j] - ad1[i][j];

        }

        return ad2;
    }

    public static double trace(double ad[][])
        throws MathException
    {
        double d = 0.0D;
        if(ad.length != ad[0].length)
            throw new MathException("Matrix is not square.");
        for(int i = 0; i < ad.length; i++)
            d += ad[i][i];

        return d;
    }

    public static double[][] transpose(double ad[][])
        throws IllegalArgumentException
    {
        int ai[] = new int[1];
        int ai1[] = new int[1];
        int j;
        int k;
        try
        {
            CheckMatrix(ad, ai, ai1);
            j = ai[0];
            k = ai1[0];
        }
        catch(IllegalArgumentException illegalargumentexception)
        {
            throw illegalargumentexception;
        }
        double ad1[][] = new double[k][j];
        for(int i = 0; i < k; i++)
        {
            for(int l = 0; l < j; l++)
                ad1[i][l] = ad[l][i];

        }

        return ad1;
    }

    static double[][] zero(int i, int j)
    {
        double ad[][] = new double[i][j];
        for(int k = 0; k < i; k++)
        {
            for(int l = 0; l < j; l++)
                ad[k][l] = 0.0D;

        }

        return ad;
    }
}
